OSDN Git Service

Merge remote-tracking branch 'toybox/master' into HEAD am: b62e8ff3da am: 63a7993a8f
[android-x86/external-toybox.git] / scripts / runtest.sh
index ce4dedf..e07c6a2 100644 (file)
@@ -2,28 +2,34 @@
 #
 # Copyright 2005 by Rob Landley
 
-# This file defines two functions, "testing" and "optionflag"
+# This file defines two main functions, "testcmd" and "optional". The
+# first performs a test, the second enables/disables tests based on
+# configuration options.
 
 # The following environment variables enable optional behavior in "testing":
 #    DEBUG - Show every command run by test script.
 #    VERBOSE - Print the diff -u of each failed test case.
 #              If equal to "fail", stop after first failed test.
-#    SKIP - do not perform this test (this is set by "optionflag")
 #
-# The "testing" function takes five arguments:
+# The "testcmd" function takes five arguments:
 #      $1) Description to display when running command
 #      $2) Command line arguments to command
 #      $3) Expected result (on stdout)
 #      $4) Data written to file "input"
 #      $5) Data written to stdin
 #
-# The exit value of testing is the exit value of the command it ran.
+# The "testing" function is like testcmd but takes a complete command line
+# (I.E. you have to include the command name.) The variable $C is an absolute
+# path to the command being tested, which can bypass shell builtins.
+#
+# The exit value of testcmd is the exit value of the command it ran.
 #
 # The environment variable "FAILCOUNT" contains a cumulative total of the
 # number of failed tests.
-
-# The "optional" function is used to skip certain tests, ala:
-#   optionflag CFG_THINGY
+#
+# The "optional" function is used to skip certain tests (by setting the
+# environment variable SKIP), ala:
+#   optional CFG_THINGY
 #
 # The "optional" function checks the environment variable "OPTIONFLAGS",
 # which is either empty (in which case it always clears SKIP) or
@@ -43,9 +49,9 @@ SHOWSKIP=SKIP
 
 if tty -s <&1
 then
-  SHOWPASS="$(echo -e "\033[1m\033[32m${SHOWPASS}\033[0m")"
-  SHOWFAIL="$(echo -e "\033[1m\033[31m${SHOWFAIL}\033[0m")"
-  SHOWSKIP="$(echo -e "\033[1m\033[33m${SHOWSKIP}\033[0m")"
+  SHOWPASS="$(echo -e "\033[1;32m${SHOWPASS}\033[0m")"
+  SHOWFAIL="$(echo -e "\033[1;31m${SHOWFAIL}\033[0m")"
+  SHOWSKIP="$(echo -e "\033[1;33m${SHOWSKIP}\033[0m")"
 fi
 
 optional()
@@ -60,18 +66,23 @@ optional()
   SKIP=1
 }
 
-# The testing function
-
-testing()
+wrong_args()
 {
-  NAME="$1"
-  [ -z "$1" ] && NAME=$2
-
   if [ $# -ne 5 ]
   then
     echo "Test $NAME has the wrong number of arguments ($# $*)" >&2
     exit
   fi
+}
+
+# The testing function
+
+testing()
+{
+  wrong_args "$@"
+
+  NAME="$CMDNAME $1"
+  [ -z "$1" ] && NAME=$2
 
   [ -n "$DEBUG" ] && set -x
 
@@ -83,19 +94,23 @@ testing()
 
   echo -ne "$3" > expected
   echo -ne "$4" > input
-  echo -ne "$5" | eval "$2" > actual
+  echo -ne "$5" | ${EVAL:-eval} "$2" > actual
   RETVAL=$?
 
-  cmp expected actual > /dev/null 2>&1
-  if [ $? -ne 0 ]
+  # Catch segfaults
+  [ $RETVAL -gt 128 ] && [ $RETVAL -lt 255 ] &&
+    echo "exited with signal (or returned $RETVAL)" >> actual
+
+  DIFF="$(diff -au${NOSPACE:+b} expected actual)"
+  if [ ! -z "$DIFF" ]
   then
     FAILCOUNT=$[$FAILCOUNT+1]
     echo "$SHOWFAIL: $NAME"
     if [ -n "$VERBOSE" ]
     then
       [ ! -z "$4" ] && echo "echo -ne \"$4\" > input"
-      echo "echo -ne '$5' | $2"
-      diff -u expected actual
+      echo "echo -ne '$5' |$EVAL $2"
+      echo "$DIFF"
       [ "$VERBOSE" == fail ] && exit 1
     fi
   else
@@ -105,7 +120,14 @@ testing()
 
   [ -n "$DEBUG" ] && set +x
 
-  return $RETVAL
+  return 0
+}
+
+testcmd()
+{
+  wrong_args "$@"
+
+  testing "$1" "$C $2" "$3" "$4" "$5"
 }
 
 # Recursively grab an executable and all the libraries needed to run it.